Text file src/make.bash

Documentation: Index

     1#!/usr/bin/env bash
     2# Copyright 2009 The Go Authors. All rights reserved.
     3# Use of this source code is governed by a BSD-style
     4# license that can be found in the LICENSE file.
     5
     6# See golang.org/s/go15bootstrap for an overview of the build process.
     7
     8# Environment variables that control make.bash:
     9#
    10# GOROOT_FINAL: The expected final Go root, baked into binaries.
    11# The default is the location of the Go tree during the build.
    12#
    13# GOHOSTARCH: The architecture for host tools (compilers and
    14# binaries).  Binaries of this type must be executable on the current
    15# system, so the only common reason to set this is to set
    16# GOHOSTARCH=386 on an amd64 machine.
    17#
    18# GOARCH: The target architecture for installed packages and tools.
    19#
    20# GOOS: The target operating system for installed packages and tools.
    21#
    22# GO_GCFLAGS: Additional go tool compile arguments to use when
    23# building the packages and commands.
    24#
    25# GO_LDFLAGS: Additional go tool link arguments to use when
    26# building the commands.
    27#
    28# CGO_ENABLED: Controls cgo usage during the build. Set it to 1
    29# to include all cgo related files, .c and .go file with "cgo"
    30# build directive, in the build. Set it to 0 to ignore them.
    31#
    32# GO_EXTLINK_ENABLED: Set to 1 to invoke the host linker when building
    33# packages that use cgo.  Set to 0 to do all linking internally.  This
    34# controls the default behavior of the linker's -linkmode option.  The
    35# default value depends on the system.
    36#
    37# GO_LDSO: Sets the default dynamic linker/loader (ld.so) to be used
    38# by the internal linker.
    39#
    40# CC: Command line to run to compile C code for GOHOSTARCH.
    41# Default is "gcc". Also supported: "clang".
    42#
    43# CC_FOR_TARGET: Command line to run to compile C code for GOARCH.
    44# This is used by cgo.  Default is CC.
    45#
    46# CXX_FOR_TARGET: Command line to run to compile C++ code for GOARCH.
    47# This is used by cgo. Default is CXX, or, if that is not set,
    48# "g++" or "clang++".
    49#
    50# FC: Command line to run to compile Fortran code for GOARCH.
    51# This is used by cgo. Default is "gfortran".
    52#
    53# PKG_CONFIG: Path to pkg-config tool. Default is "pkg-config".
    54#
    55# GO_DISTFLAGS: extra flags to provide to "dist bootstrap".
    56# (Or just pass them to the make.bash command line.)
    57#
    58# GOBUILDTIMELOGFILE: If set, make.bash and all.bash write
    59# timing information to this file. Useful for profiling where the
    60# time goes when these scripts run.
    61#
    62# GOROOT_BOOTSTRAP: A working Go tree >= Go 1.4 for bootstrap.
    63# If $GOROOT_BOOTSTRAP/bin/go is missing, $(go env GOROOT) is
    64# tried for all "go" in $PATH. $HOME/go1.4 by default.
    65
    66set -e
    67
    68export GOENV=off
    69unset GOBIN # Issue 14340
    70unset GOFLAGS
    71unset GO111MODULE
    72
    73if [ ! -f run.bash ]; then
    74	echo 'make.bash must be run from $GOROOT/src' 1>&2
    75	exit 1
    76fi
    77
    78if [ "$GOBUILDTIMELOGFILE" != "" ]; then
    79	echo $(LC_TIME=C date) start make.bash >"$GOBUILDTIMELOGFILE"
    80fi
    81
    82# Test for Windows.
    83case "$(uname)" in
    84*MINGW* | *WIN32* | *CYGWIN*)
    85	echo 'ERROR: Do not use make.bash to build on Windows.'
    86	echo 'Use make.bat instead.'
    87	echo
    88	exit 1
    89	;;
    90esac
    91
    92# Test for bad ld.
    93if ld --version 2>&1 | grep 'gold.* 2\.20' >/dev/null; then
    94	echo 'ERROR: Your system has gold 2.20 installed.'
    95	echo 'This version is shipped by Ubuntu even though'
    96	echo 'it is known not to work on Ubuntu.'
    97	echo 'Binaries built with this linker are likely to fail in mysterious ways.'
    98	echo
    99	echo 'Run sudo apt-get remove binutils-gold.'
   100	echo
   101	exit 1
   102fi
   103
   104# Test for bad SELinux.
   105# On Fedora 16 the selinux filesystem is mounted at /sys/fs/selinux,
   106# so loop through the possible selinux mount points.
   107for se_mount in /selinux /sys/fs/selinux
   108do
   109	if [ -d $se_mount -a -f $se_mount/booleans/allow_execstack -a -x /usr/sbin/selinuxenabled ] && /usr/sbin/selinuxenabled; then
   110		if ! cat $se_mount/booleans/allow_execstack | grep -c '^1 1$' >> /dev/null ; then
   111			echo "WARNING: the default SELinux policy on, at least, Fedora 12 breaks "
   112			echo "Go. You can enable the features that Go needs via the following "
   113			echo "command (as root):"
   114			echo "  # setsebool -P allow_execstack 1"
   115			echo
   116			echo "Note that this affects your system globally! "
   117			echo
   118			echo "The build will continue in five seconds in case we "
   119			echo "misdiagnosed the issue..."
   120
   121			sleep 5
   122		fi
   123	fi
   124done
   125
   126# Test for debian/kFreeBSD.
   127# cmd/dist will detect kFreeBSD as freebsd/$GOARCH, but we need to
   128# disable cgo manually.
   129if [ "$(uname -s)" = "GNU/kFreeBSD" ]; then
   130	export CGO_ENABLED=0
   131fi
   132
   133# On Alpine Linux, use the musl dynamic linker/loader
   134if [ -f "/etc/alpine-release" ]; then
   135	if type readelf >/dev/null 2>&1; then
   136		echo "int main() { return 0; }" | ${CC:-gcc} -o ./test-alpine-ldso -x c -
   137		export GO_LDSO=$(readelf -l ./test-alpine-ldso | grep 'interpreter:' | sed -e 's/^.*interpreter: \(.*\)[]]/\1/')
   138		rm -f ./test-alpine-ldso
   139	fi
   140fi
   141
   142# Clean old generated file that will cause problems in the build.
   143rm -f ./runtime/runtime_defs.go
   144
   145# Finally!  Run the build.
   146
   147verbose=false
   148vflag=""
   149if [ "$1" = "-v" ]; then
   150	verbose=true
   151	vflag=-v
   152	shift
   153fi
   154
   155export GOROOT_BOOTSTRAP=${GOROOT_BOOTSTRAP:-$HOME/go1.4}
   156export GOROOT="$(cd .. && pwd)"
   157IFS=$'\n'; for go_exe in $(type -ap go); do
   158	if [ ! -x "$GOROOT_BOOTSTRAP/bin/go" ]; then
   159		goroot=$(GOROOT='' GOOS='' GOARCH='' "$go_exe" env GOROOT)
   160		if [ "$goroot" != "$GOROOT" ]; then
   161			GOROOT_BOOTSTRAP=$goroot
   162		fi
   163	fi
   164done; unset IFS
   165echo "Building Go cmd/dist using $GOROOT_BOOTSTRAP."
   166if $verbose; then
   167	echo cmd/dist
   168fi
   169if [ ! -x "$GOROOT_BOOTSTRAP/bin/go" ]; then
   170	echo "ERROR: Cannot find $GOROOT_BOOTSTRAP/bin/go." >&2
   171	echo "Set \$GOROOT_BOOTSTRAP to a working Go tree >= Go 1.4." >&2
   172	exit 1
   173fi
   174if [ "$GOROOT_BOOTSTRAP" = "$GOROOT" ]; then
   175	echo "ERROR: \$GOROOT_BOOTSTRAP must not be set to \$GOROOT" >&2
   176	echo "Set \$GOROOT_BOOTSTRAP to a working Go tree >= Go 1.4." >&2
   177	exit 1
   178fi
   179rm -f cmd/dist/dist
   180GOROOT="$GOROOT_BOOTSTRAP" GOOS="" GOARCH="" GO111MODULE=off "$GOROOT_BOOTSTRAP/bin/go" build -o cmd/dist/dist ./cmd/dist
   181
   182# -e doesn't propagate out of eval, so check success by hand.
   183eval $(./cmd/dist/dist env -p || echo FAIL=true)
   184if [ "$FAIL" = true ]; then
   185	exit 1
   186fi
   187
   188if $verbose; then
   189	echo
   190fi
   191
   192if [ "$1" = "--dist-tool" ]; then
   193	# Stop after building dist tool.
   194	mkdir -p "$GOTOOLDIR"
   195	if [ "$2" != "" ]; then
   196		cp cmd/dist/dist "$2"
   197	fi
   198	mv cmd/dist/dist "$GOTOOLDIR"/dist
   199	exit 0
   200fi
   201
   202buildall="-a"
   203if [ "$1" = "--no-clean" ]; then
   204	buildall=""
   205	shift
   206fi
   207
   208# Run dist bootstrap to complete make.bash.
   209# Bootstrap installs a proper cmd/dist, built with the new toolchain.
   210# Throw ours, built with Go 1.4, away after bootstrap.
   211./cmd/dist/dist bootstrap $buildall $vflag $GO_DISTFLAGS "$@"
   212rm -f ./cmd/dist/dist
   213
   214# DO NOT ADD ANY NEW CODE HERE.
   215# The bootstrap+rm above are the final step of make.bash.
   216# If something must be added, add it to cmd/dist's cmdbootstrap,
   217# to avoid needing three copies in three different shell languages
   218# (make.bash, make.bat, make.rc).

View as plain text